---------------------------------
-- Serial  Controler
---------------------------------


-- Notes -----------------------------------
-- 2007.04.30
---- B
---- CLKɂ25MHz̃NbNMĂB
---- BAUD38400ƂĂ(DEFAULT115200)Acserver-coms
---- @-BIvVŐݒ肷Kv܂̂ŁAӂĂB
-- 2007.04.28
---- 낢Ə܂
---- n[hEFAIɍD܂ɂȂĂ邩ǂ͓
-- 2007.03.15
---- buffer傫܂B
-- 2007.03.14
---- 1clockɂ邩vZāA҂tF[Y܂B
---- n STATE -> wait STATE -> n+1 STATE -> wait STATE ->...
---- ƂBƂHiĂȂ炢1clockǁBj
-- 2007.03.13
---- 쐬
---- Ƃ肠A1clock1ƂŏĂ݂Ă܂B
---- rs232c̋āAv肸ƒxH130clockƂ́HHmF悤
---- ̂悤ɂȂobt@͉̕łǁA葁Ȃobt@mۂׂB
---- zmۂĂׂHƂxN^[̂΂őΉHǂɂ傫ȂRAMtH
--------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

library UNISIM;
use UNISIM.VCOMPONENTS.all;

entity SERIAL is
	port(
		CLK : in std_logic;
		RESET : in std_logic;
		--ADM
		RxD : in std_logic;
		TxD : out std_logic;
		--CPU
		DO : in std_logic;                              -- When Start 1
		WR : in std_logic;                              -- W = '1' R = '0'
		WD : in std_logic_vector(7 downto 0);
		RD : out std_logic_vector(7 downto 0);
		VALID : out std_logic;
		BUSY : out std_logic
	);
end SERIAL;

architecture ARC of SERIAL is

	signal STATE, RSTATE : std_logic_vector(3 downto 0);
	signal WBUF : std_logic_vector(7 downto 0);
	signal RBUF : std_logic_vector(7 downto 0);
	signal CNT, RCNT : std_logic_vector(7 downto 0);
	signal CLKCNT, CLKCNTW : integer;
	
	signal BWR : std_logic;
	signal BWDATA : std_logic_vector(7 downto 0);
	signal BRDATA : std_logic_vector(7 downto 0);
	signal BADDR : std_logic_vector(7 downto 0);
	
	constant CLKSPEED : integer := 25 * 1000 * 1000;
	constant BAUD : integer := 38400;--38400 * 3;   -- default
	constant CLKS : integer := (CLKSPEED / BAUD) - 1;
	constant CLKS_HF : integer := ((CLKSPEED / BAUD) / 2) - 1;
	
	component SERIAL_BUF
		port(
			CLK : in std_logic;
			RESET : in std_logic;
			WR : in std_logic;
			WDATA : in std_logic_vector(7 downto 0);
			RDATA : out std_logic_vector(7 downto 0);
			ADDR : in std_logic_vector(7 downto 0)
		);
	end component;

begin
	BINST : SERIAL_BUF port map(
		CLK => CLK,
		RESET => RESET,
		WR => BWR,
		WDATA => BWDATA,
		RDATA => BRDATA,
		ADDR => BADDR
	);
	
	process(CLK,RESET)
	begin
		if RESET = '1' then
			STATE <= "1110";
			RSTATE <= "1110";
			BUSY <= '0';
			VALID <= '0';
			CNT <= "00000000";
			RCNT <= "00000000";
			CLKCNT <= 0;
			CLKCNTW <= 0;
		elsif CLK'event and CLK = '1' then
			case RSTATE(3) is
				when '1' =>
					case RSTATE(2 downto 0) is
						when "110" => -- wait for start bit
							CLKCNT <= 0;
							BWR <= '0';
							
							if RxD = '0' then
								RSTATE <= RSTATE + 1;
							end if;
						when "111" => -- wait for 0.5 * CLKS clock
							BWR <= '0';
							
							if CLKCNT = CLKS_HF then
								CLKCNT <= 0;
								RSTATE <= RSTATE + 1;
							else
								CLKCNT <= CLKCNT + 1;
							end if;
						when "000" => -- write to buf
							CLKCNT <= 0;
							RSTATE <= "1101";
							
							BWR <= '1';
							BWDATA <= RBUF;
							BADDR <= CNT;
							CNT <= CNT + 1;
						when "101" => -- wait for CLKS clock
							BWR <= '0';
							
							if CLKCNT = CLKS then
								CLKCNT <= 0;
								RSTATE <= RSTATE + 1;
							else
								CLKCNT <= CLKCNT + 1;
							end if;
						when others =>
							CLKCNT <= 0;
							RSTATE <= "1110";
							BWR <= '0';
					end case;
				when '0' => -- read each bit
					BWR <= '0';
					
					if CLKCNT = CLKS then
						CLKCNT <= 0;
						RSTATE <= RSTATE + 1;
						RBUF(CONV_INTEGER(RSTATE(2 downto 0))) <= RxD;
					else
						CLKCNT <= CLKCNT + 1;
					end if;
				when others =>
					CLKCNT <= 0;
					RSTATE <= "1110";
					BWR <= '0';
			end case;
			
			case STATE(3) is
				when '1' =>
					case STATE(2 downto 0) is
						when "110" =>
							VALID <= '0';
							TxD <= '1';
							CLKCNTW <= 0;
							
							if DO = '1' then
								BUSY <= '1';
								
								if WR = '1' then
									WBUF <= WD;
									STATE <= STATE + 1;
								else
									STATE <= "1011";
								end if;
							end if;
						when "111" => -- start bit
							TxD <= '0';
							
							if CLKCNTW = CLKS then
								CLKCNTW <= 0;
								STATE <= STATE + 1;
							else
								CLKCNTW <= CLKCNTW + 1;
							end if;
						when "000" => -- end bit
							TxD <= '1';
							
							if CLKCNTW = CLKS then
								CLKCNTW <= 0;
								STATE <= "1110";
								BUSY <= '0';
							else
								CLKCNTW <= CLKCNTW + 1;
							end if;
						when "011" => -- ask to buf
							TxD <= '1';
							CLKCNTW <= 0;
							
							if CNT = RCNT then
								STATE <= "1011";
							elsif RSTATE = "1000" then
								STATE <= "1011";
							else
								BADDR <= RCNT;
								RCNT <= RCNT + 1;
								STATE <= STATE + 1;
							end if;
						when "100" => -- wait for data from buf
							TxD <= '1';
							CLKCNTW <= 0;
							STATE <= STATE + 1;
						when "101" =>
							TxD <= '1';
							CLKCNTW <= 0;
							STATE <= STATE + 1;
							
							RD <= BRDATA;
							VALID <= '1';
							BUSY <= '0';
						when others =>
							TxD <= '1';
							CLKCNTW <= 0;
							STATE <= "1110";
					end case;
				when '0' =>
					TxD <= WBUF(CONV_INTEGER(STATE(2 downto 0)));
					
					if CLKCNTW = CLKS then
						CLKCNTW <= 0;
						STATE <= STATE + 1;
					else
						CLKCNTW <= CLKCNTW + 1;
					end if;
				when others =>
					TxD <= '1';
					CLKCNTW <= 0;
					STATE <= "1110";
			end case;
		end if;
	end process;
end ARC;
